## libkqueue 1.0.4

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2009 Mark Heily <mark@heily.com>
+# Copyright (c) 2009-2011 Mark Heily <mark@heily.com>
 #
 # Permission to use, copy, modify, and distribute this software for any
 # purpose with or without fee is hereby granted, provided that the above
@@ -60,6 +60,9 @@
 check: $(PROGRAM).a
 	cd test && ./configure && make check
 
+debug-check: clean $(PROGRAM).a
+	cd test && ./configure && KQUEUE_DEBUG=y make check
+
 $(DISTFILE): $(SOURCES) $(HEADERS)
 	mkdir $(PROGRAM)-$(VERSION)
 	cp  Makefile ChangeLog configure config.inc      \
@@ -75,19 +78,18 @@
 	rm -f $(DISTFILE)
 	make $(DISTFILE)
 
-dist-upload: dist
-	scp $(PROGRAM)-$(VERSION).tar.gz $(DIST)
-
-publish-www:
-	cp -R www/* ~/public_html/libkqueue/
+dist-upload: $(DISTFILE)
+	scp $(DISTFILE) $(DIST)
 
 clean:
-	rm -f tags *.a $(OBJS) *.so *.so.*
+	rm -f tags *.a *.so *.so.*
+	find src -name '*.o' -exec rm {} \;
 	rm -rf pkg
 	cd test && make clean || true
 
 distclean: clean
 	rm -f *.tar.gz config.mk config.h $(PROGRAM).pc $(PROGRAM).la rpm.spec
+	rm -f test/config.mk test/config.h
 	rm -rf $(PROGRAM)-$(VERSION) 2>/dev/null || true
 
 fresh-build:
@@ -111,16 +113,18 @@
 cscope: tags
 	cscope $(SOURCES) $(HEADERS)
 
-rpm: clean $(DISTFILE)
-	rm -rf rpm *.rpm *.deb
-	mkdir -p rpm/BUILD rpm/RPMS rpm/SOURCES rpm/SPECS rpm/SRPMS
-	mkdir -p rpm/RPMS/i386 rpm/RPMS/x86_64
-	cp $(DISTFILE) rpm/SOURCES 
+# Creates an ~/rpmbuild tree
+rpmbuild:
+	mkdir -p $$HOME/rpmbuild
+	cd $$HOME/rpmbuild && mkdir -p BUILD RPMS SOURCES SPECS SRPMS
+	grep _topdir $$HOME/.rpmmacros || \
+           echo "%_topdir %(echo $$HOME/rpmbuild)" >> $$HOME/.rpmmacros
+
+rpm: rpmbuild clean $(DISTFILE)
+	mkdir -p pkg
+	cp $(DISTFILE) $$HOME/rpmbuild/SOURCES 
 	rpmbuild -bb rpm.spec
-	mv ./rpm/RPMS/* .
-	rm -rf rpm
-	rmdir i386 x86_64    # WORKAROUND: These aren't supposed to exist
-	fakeroot alien --scripts *.rpm
+	find $$HOME/rpmbuild -name '$(PROGRAM)-$(VERSION)*.rpm' -exec mv {} ./pkg \;
 
 deb: clean $(DISTFILE)
 	mkdir pkg && cd pkg ; \
@@ -145,3 +149,17 @@
 	if [ "`pwd | grep /branches/stable`" != "" ] ; then \
 	   (cd ../.. ; $(DIFF) branches/stable trunk | less) ; \
     fi
+
+# Copy to/from the host to the Solaris guest VM
+#
+solaris-push:
+	ssh -p 2222 localhost 'rm -rf /export/home/mheily/libkqueue'
+	cd .. ; scp -rq -P 2222 trunk localhost:/export/home/mheily/libkqueue
+
+solaris-test: solaris-push
+	ssh -p 2222 localhost 'cd /export/home/mheily/libkqueue && /usr/sfw/bin/gmake distclean && ./configure && /usr/sfw/bin/gmake clean all check'
+
+solaris-pull:
+	scp -rq -P 2222 localhost:/export/home/mheily/libkqueue/\* .
+#
+#
