=== test/Makefile ===
--- 
+++ 
@@ -38,10 +38,11 @@
 
 distclean: clean 
 	rm -f config.mk config.h
-	for x in libdispatch stress; do cd $$x && make distclean ; done
+	for x in libdispatch stress; do cd $$x && make distclean && cd .. ; done
 
 edit:
 	$(EDITOR) *.[ch]
 
 clean:
 	rm -f *.o *.a kqtest
+	for x in libdispatch stress; do cd $$x && make clean && cd ..; done
