=== debian/changelog ===
libkqueue (1.0.4-2ubuntu1) precise; urgency=low

  * Backported fixes from upstream SVN to fix FTBFS. (LP: #852592)

 -- Daniel T Chen <crimsun@ubuntu.com>  Thu, 01 Mar 2012 19:29:58 -0500

libkqueue (1.0.4-2) unstable; urgency=low

  * Integrate patches from Matthias Klose (Closes: #640029)
    * Add -Wno-error=unused-result to CFLAGS
    * Fix header checks for multiarch locations.

 -- Mark Heily <mark@heily.com>  Thu, 27 Oct 2011 20:58:03 -0400

libkqueue (1.0.4-1) unstable; urgency=low

  * Fix a FTBFS on 32-bit platforms caused by the use of /usr/lib64
  * Fix a lintian warning related to the copyright file

 -- Mark Heily <mark@heily.com>  Wed, 13 Jul 2011 20:52:41 -0400

libkqueue (1.0.3-1) unstable; urgency=low

  * New upstream release (Closes: #625639)
  * Update control file with new website and standards version
  * Simplify the debian/rules file using debhelper for everything
  * Upgrade source/format to "3.0 (quilt)"
  * Remove the debian/watch file

 -- Mark Heily <mark@heily.com>  Sat, 09 Jul 2011 18:56:19 -0400

libkqueue (0.9.2-2) unstable; urgency=low

  * Apply patch to fix a bug in EV_RECEIPT (Closes: #595648)

 -- Mark Heily <mark@heily.com>  Sun, 05 Sep 2010 13:57:45 -0400

libkqueue (0.9.2-1) unstable; urgency=low

  * New upstream release (Closes: #591818)

 -- Mark Heily <mark@heily.com>  Thu, 05 Aug 2010 23:31:18 -0400

libkqueue (0.9.1-1) unstable; urgency=low

  * New upstream release

 -- Mark Heily <mark@heily.com>  Wed, 04 Aug 2010 21:35:01 -0400

libkqueue (0.8-1) unstable; urgency=low

  * New upstream release

 -- Mark Heily <mark@heily.com>  Sun, 25 Jul 2010 10:09:35 -0400

libkqueue (0.7-1) unstable; urgency=low

  * Initial release (Closes: #576317)

 -- Mark Heily <mark@heily.com>  Sun, 28 Mar 2010 18:58:58 -0400
