=== debian/control ===
Source: libkqueue
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mark Heily <mark@heily.com>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.9.2
Vcs-Svn: svn://mark.heily.com/libkqueue
Homepage: http://mark.heily.com/project/libkqueue

Package: libkqueue0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: cross-platform library for kernel event notification
 libkqueue is a portable userspace implementation of the kqueue(2) 
 kernel event notification mechanism found in FreeBSD and other BSD-based 
 operating systems. The library translates between the kevent structure 
 and the native kernel facilities of the host machine.

Package: libkqueue-dev
Section: libdevel
Architecture: any
Depends: libkqueue0 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libkqueue
 Contains the header files, manpages, and static libraries for use in 
 developing applications that use the libkqueue library.
 .
 libkqueue is a portable userspace implementation of the kqueue(2) 
 kernel event notification mechanism found in FreeBSD and other BSD-based 
 operating systems. The library translates between the kevent structure 
 and the native kernel facilities of the host machine.
