## libkqueue 2.0.3

=== debian/changelog ===
libkqueue (2.0.3-1.1) unstable; urgency=medium

  * Non maintainer upload.
  * Fix build failures on 64bit architectures. Closes: #760302, #754376.
    - Replacing preprocessor macro X86_64 to LP64 in knote.c, since
      it is used to treat pointer rather than processor specifics (Fernando
      Seiti Furusat).

 -- Matthias Klose <doko@debian.org>  Thu, 11 Sep 2014 13:52:07 +0200

libkqueue (2.0.3-1) unstable; urgency=low

  * New upstream release (closes: #741009)

 -- Mark Heily <mark@heily.com>  Sun, 09 Mar 2014 20:45:35 -0400

libkqueue (2.0.2-1) unstable; urgency=low

  * New upstream release (closes: #724170, #669572, #729591)

 -- Mark Heily <mark@heily.com>  Sun, 23 Feb 2014 16:04:08 -0500
