=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: libkqueue
 Section: libs
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mark Heily <mark@heily.com>
-Build-Depends: debhelper (>= 7)
-Standards-Version: 3.9.2
-Vcs-Svn: svn://mark.heily.com/libkqueue
-Homepage: http://mark.heily.com/project/libkqueue
+Maintainer: Mark Heily <mark@heily.com>
+Build-Depends: debhelper (>= 9), dh-autoreconf, autotools-dev
+Standards-Version: 3.9.5.0
+Vcs-Git: git://github.com/mheily/debian-packages.git -b libkqueue
+Homepage: https://github.com/mheily/libkqueue/wiki
 
 Package: libkqueue0
 Architecture: any
