=== debian/changelog ===
libkqueue (2.3.1-1) unstable; urgency=medium

  * New upstream release

 -- Mark Heily <mark@heily.com>  Mon, 06 Apr 2020 23:57:02 +0000

libkqueue (2.0.3-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with GCC. (Closes: #831076)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 19 Mar 2020 19:47:14 +0000
