=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: libkqueue
 Section: libs
-Priority: extra
+Priority: optional
 Maintainer: Mark Heily <mark@heily.com>
-Build-Depends: debhelper (>= 9), dh-autoreconf, autotools-dev
-Standards-Version: 3.9.5.0
-Vcs-Git: git://github.com/mheily/debian-packages.git -b libkqueue
+Build-Depends: debhelper-compat (= 12), cmake
+Standards-Version: 4.5.0
+Vcs-Git: https://github.com/mheily/debian-packages.git -b libkqueue
+Vcs-Browser: https://github.com/mheily/debian-packages/tree/libkqueue
 Homepage: https://github.com/mheily/libkqueue/wiki
 
 Package: libkqueue0
