=== debian/tests/control ===
Tests: kqtest
Depends: libkqueue0
