=== test/libdispatch/Makefile ===
--- 
+++ 
@@ -13,4 +13,4 @@
 	rm -f *.o
 
 distclean: clean
-	rm -f disptest 
+	rm -f disptest
