=== debian/control ===
Source: libkqueue
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Homepage: https://github.com/mheily/libkqueue/wiki
Rules-Requires-Root: no
Standards-Version: 4.6.2
Build-Depends: cmake,
               debhelper-compat (= 13),
               dpkg-dev (>= 1.22.5),
               ninja-build

Package: libkqueue0t64
Provides: ${t64:Provides}
Replaces: libkqueue0
Breaks: libkqueue0 (<< ${source:Version})
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: cross-platform library for kernel event notification
 libkqueue is a portable userspace implementation of the kqueue(2) kernel
 event notification mechanism found in FreeBSD and other BSD-based operating
 systems. The library translates between the kevent structure and the
 native kernel facilities of the host machine.

Package: libkqueue-dev
Section: libdevel
Architecture: any
Depends: libkqueue0t64 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libkqueue
 Contains the header files, manpages, and static libraries for use in
 developing applications that use the libkqueue library.
 .
 libkqueue is a portable userspace implementation of the kqueue(2) kernel
 event notification mechanism found in FreeBSD and other BSD-based operating
 systems. The library translates between the kevent structure and the
 native kernel facilities of the host machine.
