=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libkqueue-$1\.tar\.gz/ \
https://github.com/mheily/libkqueue/tags .*/v?(\d\S+)@ARCHIVE_EXT@

##https://github.com/mheily/libkqueue/tags .*/v?(\d\S+)\.tar\.gz
